unit DS18B20;

interface

uses
Graphics,Dialogs,Windows;

procedure Conv_T;
Function Read_T:extended;
function TReset:Boolean;
procedure WriteOW(x : Byte);
function ReadOW : Byte;

implementation
uses TxRx, SysUtils,Glav, sensor;

 var
  CRC : Byte = 0;

Const
  ResBR=9600;    //Reset Baud Rate
  SltBR=115200;  //Time slot Baud Rate

  (***********************************)
//   1-Wire


  //TouchReset:

function TReset:Boolean;
var
 B:Byte;
 D,time:DWord;
begin
 Result:=False;
 SetModCom(ResBR,8,NOPARITY,ONESTOPBIT,true,false);
 PurgeCom;
 TxByteCOM($F0);
 time:=GetTickCount+50;
 repeat RxDataCOM(B,1,D)
  until (D=1) or (time<GetTickCount);
 if D=1
  then Result:=(B<>$F0);
 Present:=Result;
end;
(***********************************)
//   1-Wire

function ResetOW : Boolean;
 var
  b   : Byte;
  d,t : Cardinal;

 begin
  Result := FALSE;

  SetModCOM(9600,8,NOPARITY,ONESTOPBIT,TRUE,FALSE);
  PurgeCOM;
  TxByteCOM($F0);
  t := GetTickCount + 50;

  repeat
   RxDataCOM(b,1,d)
  until (d = 1) or (t < GetTickCount);
  SetModCOM(115200,8,NOPARITY,ONESTOPBIT,TRUE,FALSE);
  if d = 1 then Result := b <> $F0;
 end;


(********************************************)
 //     

procedure WriteOW(x : Byte);
 var
  n,b : Byte;
  d,t : Cardinal;
 begin
  PurgeCOM;
  t := GetTickCount + 50;
  for n := 1 to 8 do
   begin
    if Odd(x) then TxByteCOM($FF) else TxByteCOM($00);
     x := x shr 1;
    repeat
     RxDataCOM(b,1,d)
    until (d = 1) or (t < GetTickCount);

    if d <> 1 then Exit;
   end;
 end;

(***********************************)
   //     

function ReadOW : Byte;
 var
  n,b,x : Byte;
  d,t   : Cardinal;

 begin
  Result := $FF;
  PurgeCOM;
  t := GetTickCount + 50;
  x := 0;

  for n := 1 to 8 do
   begin
    TxByteCOM($FF);
    x := x shr 1;
    repeat
     RxDataCOM(b,1,d)
    until (d = 1) or (t < GetTickCount);

    if d <> 1 then Exit;
    if Odd(b) then x := x or $80;
   end;
  Result := x;
 end;

(***********************************)

 //  8-  

procedure UpdateCRC(b : Byte);
 var
  i : Byte;

 begin
  for i := 1 to 8 do
   begin
    if ((b xor CRC) and 1) > 0 then CRC := ((CRC xor $18) shr 1) or $80
     else CRC := CRC shr 1;

    b := b shr 1;
   end;
 end;
 (***********************************)
//     
{***********************************}
   //     

procedure Conv_T;
 begin
if not ResetOW then exit;// if ResetOW then  //  1.	.
        WriteOW($CC); //   2.	  ( CCh ) -  ROM.
        WriteOW($44); //4.	   ( 44h ) -  .
 end;

(*********************************)
//     

Function Read_T:extended;
 var
 temp_byte,temp_byte1,
 temp_byte2,temp_byte3,
 temp_byte4,temp_byte5,
 temp_byte6,temp_byte7,
 temp_byte8:byte;
 T: extended;
 begin
  if not ResetOW then
                begin
                 F_Glav.Timer1.Enabled:=False;
                 MessageDlg('   .',mtError,[mbOk],0);
                 exit;  // if ResetOW then   //  1.	.
                end;
        WriteOW($CC);//   2.	  ( CCh ) -  ROM.
        WriteOW($BE);  //  4.	   ( BEh ) -  .

 (*-----------------------------*)
       //

       temp_byte :=ReadOW;  //  .  .
       temp_byte1:=ReadOW;  //  .  .
       temp_byte2:=ReadOW;  //   
       temp_byte3:=ReadOW;  //   
       temp_byte4:=ReadOW;  //   ( .)
       temp_byte5:=ReadOW;  //  
       temp_byte6:=ReadOW;  //  Count_Remain
       temp_byte7:=ReadOW;  //  Count_Per_C
       temp_byte8:=ReadOW;  //   CRC8.
      
    

       CRC := 0;
       UpdateCRC(temp_byte);   //  .  .
       UpdateCRC(temp_byte1);  //  .  .
       UpdateCRC(temp_byte2);  //   
       UpdateCRC(temp_byte3);  //   
       UpdateCRC(temp_byte4);  //   ( .)
       UpdateCRC(temp_byte5);  //  
       UpdateCRC(temp_byte6);  //  Count_Remain
       UpdateCRC(temp_byte7);  //  Count_Per_C

   if temp_byte8=CRC then
   begin
  (*-----------------------------*)
       //  
        if temp_byte1 <= 7 then
           T := ((temp_byte1 shl 8) or temp_byte) / 16
          else
           T := -(65536 - ((temp_byte2 shl 8) or temp_byte)) / 16;
   end;

   Read_T:=T;

 end;


(******************************************)
end.
