unit Fuzzy_PID;

interface

Function PID(Otklonenie:Real):Real;
procedure tablica(ij:integer);
Function Fuzzy(pos_otklon:extended; Intg:boolean):real;
procedure Clear_Term;

implementation

uses SysUtils,Graphics,Glav;
 var
  M_pid1:byte=1;{}
  M_pid2:byte=1;{}
  E1_1:REAL;
  E1_2:REAL;
(*========================================*)

  (*********    ***********************)
{ E    }
{ E1     }
{ M:INT;{ }
{        =1}
{ U:REAL;{  }
  { P -  C0}
  { I -      C1 }
  { D -  C2  }

  {}
{U=U1-C0*E+C1*E1+C2*E2
C0=Ku*(1+Td/T0)
C1=Ku*(1+2Td/T0-T0/Ti)
C2=Ku*Td/T0    }

{* PID subprogram, call cyclically *}
Function PID(Otklonenie:Real):Real;
  var
 U:REAL;{ 2}
  E:REAL;

BEGIN
 E:=Otklonenie;
IF M_pid2=1 THEN
BEGIN
E1_2:=E;
SUM2:=E;
U:=0;

if F_Glav.Check_Reg2_Prop.Checked=True then
begin U:=U+C0_2*E;end;
(*----------------------------*)
if F_Glav.Check_Reg2_Integ.Checked=True then
begin U:=U+C1_2*SUM2; end;

M_pid2:=0;
END

ELSE
BEGIN
U:=0;
SUM2:=SUM2+E;

 if SUM2>1000000 then
 begin SUM2:=1000000; end;

if F_Glav.Check_Reg2_Prop.Checked=True then
    begin
      U:=U+C0_2*E;
      F_Glav.Ind_Reg2_Prop.Caption:= formatFloat('0.00',(0.427*C0_2*E));
    end;
(*----------------------------*)
if F_Glav.Check_Reg2_Integ.Checked=True then
    begin
      U:=U+C1_2*SUM2;
      F_Glav.Ind_Reg2_Integ.Caption:=formatFloat('0.00',(0.427*C1_2*SUM2));
    end;
(*----------------------------*)
if F_Glav.Check_Reg2_Diff.Checked=True then
    begin
       U:=U+C2_2*(E-E1_2);
       F_Glav.Ind_Reg2_Diff.Caption:= formatFloat('0.00',(0.427*C2_2*(E-E1_2)));
    end;
(*----------------------------*)
PID:=0.427*U;

E1_2:=E;
END;


END;


(*************************************)
procedure Tablica( ij:integer);
 begin
  if (ij and 1)=1 then F_Glav.MaskEdit1.Color:=clGreen
  else   F_Glav.MaskEdit1.Color:=clWindow;

  if (ij and 2)=2 then F_Glav.MaskEdit2.Color:=clGreen
  else   F_Glav.MaskEdit2.Color:=clWindow;

  if (ij and 4)=4 then F_Glav.MaskEdit3.Color:=clGreen
  else   F_Glav.MaskEdit3.Color:=clWindow;

  if (ij and 8)=8 then F_Glav.MaskEdit4.Color:=clGreen
  else   F_Glav.MaskEdit4.Color:=clWindow;

  if (ij and 16)=16 then F_Glav.MaskEdit5.Color:=clGreen
  else   F_Glav.MaskEdit5.Color:=clWindow;

  if (ij and 32)=32 then F_Glav.MaskEdit6.Color:=clGreen
  else   F_Glav.MaskEdit6.Color:=clWindow;

  if (ij and 64)=64 then F_Glav.MaskEdit7.Color:=clGreen
  else   F_Glav.MaskEdit7.Color:=clWindow;

  if (ij and 128)=128 then F_Glav.MaskEdit8.Color:=clGreen
  else   F_Glav.MaskEdit8.Color:=clWindow;

  if (ij and 256)=256 then F_Glav.MaskEdit9.Color:=clGreen
  else   F_Glav.MaskEdit9.Color:=clWindow;

  end;

   (********************************************)
procedure Clear_Term;  //   
    begin
          F_Glav.Chart1.SeriesList[0].Clear;
          F_Glav.Chart1.SeriesList[1].Clear;
          F_Glav.Chart1.SeriesList[2].Clear;
          F_Glav.Chart1.SeriesList[3].Clear;//   
          F_Glav.Chart2.SeriesList[0].Clear;
          F_Glav.Chart2.SeriesList[1].Clear;
          F_Glav.Chart2.SeriesList[2].Clear;
          F_Glav.Chart2.SeriesList[3].Clear;
    end;

{*****************************************}
Function Fuzzy(pos_otklon:extended; Intg:boolean):real;
var
 Tem_dat: array [0..22] of extended;
 jach_T: array [0..22] of byte;
 jach_My: array [0..22] of real;
 ja_T_rez: array [0..22] of byte;
 ja_My_rez: array [0..22] of real;

  num_jach_prinad,num,ii:byte;
  i,T_cel,T_sot,Temp,Vib_jach:integer;
  my,my1,my2,my3,my4,my5,my_mal_skor,my_norm_skor,my_bol_skor,
  my_mal_otkl,my_norm_otkl,my_bol_otkl, my_min1,my_min2,my_min3,my_min4,
  my_min5,my_min6,my_min7,my_min8,my_min9,max,P_temp,P: real;

 U:REAL;{ }
 E:REAL;
 E_dif,pos_skor:real;

 U_out:REAL;{  }
  (****************************************)


 begin



 {* PID subprogram, call cyclically *}

BEGIN
 E:= pos_otklon;
IF M_pid1=1 THEN
BEGIN
E1_1:=E;
SUM1:=E;
U:=0;

if F_Glav.Check_Reg1_Prop.Checked=True then
begin U:=U+C0_1*E; end;
(*----------------------------*)
if F_Glav.Check_Reg1_Integ.Checked=True then
begin U:=U+C1_1*SUM1; end;

M_pid1:=0;
END

ELSE
BEGIN
U:=0;
SUM1:=SUM1+E;
 if SUM1>1000000 then
 begin SUM1:=1000000; end;

if F_Glav.Check_Reg1_Prop.Checked=True then
   begin //F_Glav.Ed_Reg1_Prop.Visible:=true;
        // F_Glav.Ind_Reg1_Prop.Visible:=true;
          U:=U+C0_1*E;
         F_Glav.Ind_Reg1_Prop.Caption:= formatFloat('0.00',(0.427*C0_1*E));
   end
 else  begin E_dif:=0;//F_Glav.Ed_Reg1_Prop.Visible:=False;
             //F_Glav.Ind_Reg1_Prop.Visible:=False;
       end;
(*----------------------------*)
if F_Glav.Check_Reg1_Integ.Checked=True then
  begin
     // F_Glav.Ed_Reg1_Integ.Visible:=true;
     // F_Glav.Ind_Reg1_Integ.Visible:=true;
      F_Glav.Ind_Reg1_Integ.Caption:=formatFloat('0.00',(0.427*C1_1*SUM1));
        U:=U+C1_1*SUM1;
  end
 else  begin SUM1:=0;
            // F_Glav.Ed_Reg1_Integ.Visible:=False;
            // F_Glav.Ind_Reg1_Integ.Visible:=false;
       end;
(*----------------------------*)
if F_Glav.Check_Reg1_Diff.Checked=True then
  begin// F_Glav.Ed_Reg1_Diff.Visible:=true;
       // F_Glav.Ind_Reg1_Diff.Visible:=true;
        E_dif:=E-E1_1;
         U:=U+C2_1*E_dif;
        F_Glav.Ind_Reg1_Diff.Caption:= formatFloat('0.00',0.427*C2_1*E_dif);
  end
  else  begin E_dif:=0;
            //  F_Glav.Ed_Reg1_Diff.Visible:=False;
            //  F_Glav.Ind_Reg1_Diff.Visible:=false;
        end;
(*----------------------------*)

E1_1:=E;

END;
END;

Clear_Term;   //   


 pos_skor:=E_dif; //    


   if pos_otklon > otkl_right/10 then pos_otklon:=otkl_right/10;
if pos_otklon <(-1*otkl_left/10) then pos_otklon:=(-1*otkl_left/10);


   if pos_skor > skor_right/10 then pos_skor:=skor_right/10;
if pos_skor <(-1*skor_left/10) then pos_skor:=(-1*skor_left/10);


         //   
        F_Glav.Chart1.SeriesList[0].AddXY((pos_otklon),0);//  
        F_Glav.Chart1.SeriesList[0].AddXY((pos_otklon),1); // 

           //   
        F_Glav.Chart2.SeriesList[0].AddXY((pos_skor),0);//  
        F_Glav.Chart2.SeriesList[0].AddXY((pos_skor),1);// 


(********************************************)
 //      

  for i:= round(-1*otkl_left) to round(otkl_right) do
  begin
  if i/10 <= (-1*otkl_A1) then begin my:=1;  end;
  if (i/10 > (-1*otkl_A1)) and (i/10<=(-1*otkl_B1)) then
      begin my:=(((-1*otkl_B1)-i/10)/((-1*otkl_B1)-(-1*otkl_A1))); end;
  if i/10 >(-1*otkl_B1) then  begin my:=0; end;

       F_Glav.Chart1.SeriesList[1].AddXY(i/10,(my),FloatToStr(i/10));
  (*------------------------------------------*)

  if i/10 <= (-1*otkl_A2) then  begin my1:=0; end;
  if (i/10 > (-1*otkl_A2)) and (i/10<= (otkl_B2)) then
   begin my1:=((i/10-(-1*otkl_A2))/(-1*otkl_B2-(-1*otkl_A2)));  end;
  if (i/10 > (-1*otkl_B2)) and (i/10<= otkl_C2) then
   begin my1:=((otkl_C2-i/10)/(otkl_C2-otkl_B2));    end;
  if i/10 > otkl_C2 then  begin my1:=0;  end;

      F_Glav.Chart1.SeriesList[2].AddXY(i/10,(my1),FloatToStr(i/10));
 (*------------------------------------------*)
  if i/10 <= otkl_A3 then begin my2:=0; end;
  if (i/10 > otkl_A3) and (i/10<=otkl_B3) then
   begin my2:=((i/10-otkl_A3)/(otkl_B3-otkl_A3));  end;
  if i/10 >otkl_B3 then begin my2:=1; end;

      F_Glav.Chart1.SeriesList[3].AddXY(i/10,(my2),FloatToStr(i/10));
   end;


    (**************************************************)
 //    

for i:= round(-1*skor_left) to round(skor_right) do
  begin

  if i/10 <=(-1*skor_A1) then my:=1;
  if (i/10 > (-1*skor_A1)) and (i/10<=(-1*skor_B1)) then
     my:=(((-1*skor_B1)-i/10)/((-1*skor_B1)-(-1*skor_A1)));
  if i/10 >(-1*skor_B1) then my:=0;

      F_Glav.Chart2.SeriesList[1].AddXY(i/10,(my),FloatToStr(i/10));
 (*------------------------------------------*)

  if i/10 <= (-1*skor_A2)  then my1:=0;
  if (i/10 > (-1*skor_A2)) and (i/10<=(-1*skor_B2)) then
         my1:=((i/10-(-1*skor_A2))/(-1*skor_B2-(-1*skor_A2)));
  if (i/10 > (-1*skor_B2)) and (i/10<=skor_C2)      then
         my1:=((skor_C2-i/10)/(skor_C2-skor_B2));
  if (i/10 > (skor_C2))    then my1:=0;

      F_Glav.Chart2.SeriesList[2].AddXY(i/10,(my1),FloatToStr(i/10));
(*------------------------------------------*)

  if i/10 <= skor_A3    then my2:=0;
  if (i/10 > skor_A3) and (i/10<=skor_B3) then my2:=((i/10-skor_A3)/(skor_B3-skor_A3));
  if i/10 >skor_B3      then my2:=1;

      F_Glav.Chart2.SeriesList[3].AddXY(i/10,(my2),FloatToStr(i/10));
(*------------------------------------------*)
 end;




 (****************************************)
  //  ,   

 begin
  if pos_otklon <= (-1*otkl_A1) then begin   my_mal_otkl:=1; end;
  if (pos_otklon > (-1*otkl_A1)) and (pos_otklon<=(-1*otkl_B1)) then
   begin my_mal_otkl:=(((-1*otkl_B1)-pos_otklon)/((-1*otkl_B1)-(-1*otkl_A1)));  end;
  if pos_otklon >otkl_B1 then  begin  my_mal_otkl:= 0; end;
       F_Glav.ind_mal_otkl.Caption:=formatFloat('0.00',(my_mal_otkl));
        (*------------------------------------------*)
  if pos_otklon <= (-1*otkl_A2) then  begin  my_norm_otkl:=0; end;
  if (pos_otklon > (-1*otkl_A2)) and (pos_otklon<=0) then
    begin my_norm_otkl:= ((pos_otklon-(-1*otkl_A2))/(-1*otkl_B2-(-1*otkl_A2))); end;
  if (pos_otklon >(-1*otkl_B2)) and (pos_otklon<=otkl_C2) then
    begin my_norm_otkl:=((otkl_C2-pos_otklon)/(otkl_C2-otkl_B2)); end;
  if pos_otklon > otkl_C2 then  begin my_norm_otkl:=0; end;
      F_Glav.ind_norm_otkl.Caption:=formatFloat('0.00',(my_norm_otkl));
 (*------------------------------------------*)
  if pos_otklon <= otkl_A3 then begin my_bol_otkl:=0; end;
  if (pos_otklon > otkl_A3) and (pos_otklon<=otkl_B3) then
     begin  my_bol_otkl:=((pos_otklon-otkl_A3)/(otkl_B3-otkl_A3));  end;
  if pos_otklon >otkl_B3 then begin my_bol_otkl:=1; end;
    F_Glav.ind_bol_otkl.Caption:=formatFloat('0.00',(my_bol_otkl));

      (*------------------------------------------*)

      //    

  if pos_skor <= (-1*skor_A1) then begin   my_mal_skor:=1; end;
  if (pos_skor > (-1*skor_A1)) and (pos_skor<=(-1*skor_B1)) then
    begin my_mal_skor:=(((-1*skor_B1)-pos_skor)/((-1*skor_B1)-(-1*skor_A1))); end;
  if pos_skor >(-1*skor_B1) then  begin  my_mal_skor:= 0; end;

   F_Glav.ind_mal_skor.Caption:=formatFloat('0.00',(my_mal_skor));
 (*------------------------------------------*)
  if pos_skor <= (-1*skor_A2) then  begin  my_norm_skor:=0; end;

  if (pos_skor > (-1*skor_A2)) and (pos_skor<=(-1*skor_B2)) then
  begin my_norm_skor:=((pos_skor-(-1*skor_A2))/(-1*skor_B2-(-1*skor_A2)));end;

  if (pos_skor > (-1*skor_B2)) and (pos_skor<=skor_C2) then
  begin my_norm_skor:=((skor_C2-pos_skor)/(skor_C2-skor_B2)); end;

  if pos_skor > skor_C2 then  begin my_norm_skor:=0; end;

     F_Glav.ind_norm_skor.Caption:=formatFloat('0.00',(my_norm_skor));
 (*------------------------------------------*)
  if pos_skor <= skor_A3 then begin my_bol_skor:=0; end;
  if (pos_skor > skor_A3) and (pos_skor<=skor_B3) then
   begin  my_bol_skor:=((pos_skor-skor_A3)/(skor_B3-skor_A3));  end;
  if pos_skor >skor_B3 then begin my_bol_skor:=1; end;

    F_Glav.ind_bol_skor.Caption:=formatFloat('0.00',(my_bol_skor));
      (*------------------------------------------*)
      end;

    Tablica(0);
    Vib_jach:=0;
    num_jach_prinad:=0;

    my_min1:=0;
    my_min2:=0;
    my_min3:=0;
    my_min4:=0;
    my_min5:=0;
    my_min6:=0;
    my_min7:=0;
    my_min8:=0;
    my_min9:=0;
    (*    +   *)

  (* 1 *)   if (my_mal_otkl > 0) and (my_mal_skor > 0) then
  begin Vib_jach:=Vib_jach+1; num_jach_prinad:=num_jach_prinad+1;
    if (my_mal_otkl >my_mal_skor ) then my_min1:=my_mal_skor
    else  my_min1:=my_mal_otkl; end;

  (* 2 *)   if (my_mal_otkl > 0) and (my_norm_skor > 0) then
  begin Vib_jach:=Vib_jach+2;num_jach_prinad:=num_jach_prinad+1;
   if (my_mal_otkl >my_norm_skor ) then my_min2:=my_norm_skor
    else  my_min2:=my_mal_otkl; end;


  (* 3 *)   if (my_mal_otkl > 0) and (my_bol_skor > 0) then
  begin Vib_jach:=Vib_jach+4;num_jach_prinad:=num_jach_prinad+1;
   if (my_mal_otkl >my_bol_skor ) then my_min3:=my_bol_skor
    else  my_min3:=my_mal_otkl; end;


  (*------------------------------------------*)

  (* 4 *)   if (my_norm_otkl > 0) and (my_mal_skor > 0) then
  begin Vib_jach:=Vib_jach+8;num_jach_prinad:=num_jach_prinad+1;
   if (my_norm_otkl >my_mal_skor ) then my_min4:=my_mal_skor
    else  my_min4:=my_norm_otkl; end;


  (* 5 *)   if (my_norm_otkl > 0) and (my_norm_skor > 0) then
  begin Vib_jach:=Vib_jach+16;num_jach_prinad:=num_jach_prinad+1;
   if (my_norm_otkl >my_norm_skor ) then my_min5:=my_norm_skor
    else  my_min5:=my_norm_otkl; end;


  (* 6 *)   if (my_norm_otkl > 0) and (my_bol_skor > 0) then
  begin Vib_jach:=Vib_jach+32;num_jach_prinad:=num_jach_prinad+1;
   if (my_norm_otkl >my_bol_skor ) then my_min6:=my_bol_skor
    else  my_min6:=my_norm_otkl; end;


  (*------------------------------------------*)

  (* 7 *)   if (my_bol_otkl > 0) and (my_mal_skor > 0) then
  begin Vib_jach:=Vib_jach+64;num_jach_prinad:=num_jach_prinad+1;
   if (my_bol_otkl >my_mal_skor ) then my_min7:=my_mal_skor
    else  my_min7:=my_bol_otkl; end;


  (* 8 *)   if (my_bol_otkl > 0) and (my_norm_skor > 0) then
  begin Vib_jach:=Vib_jach+128;num_jach_prinad:=num_jach_prinad+1;
   if (my_bol_otkl >my_norm_skor ) then my_min8:=my_norm_skor
    else  my_min8:=my_bol_otkl; end;


  (* 9 *)   if (my_bol_otkl > 0) and (my_bol_skor > 0) then
  begin Vib_jach:=Vib_jach+256;num_jach_prinad:=num_jach_prinad+1;
   if (my_bol_otkl >my_bol_skor ) then my_min9:=my_bol_skor
    else  my_min9:=my_bol_otkl; end;


     Tablica(Vib_jach);

{**********    *************}
  for num:=1 to 20 do begin jach_T[ num ]:=0; jach_My[ num ]:=0;
                            ja_T_rez[num]:=0; ja_My_rez[num]:=0; end;

//      jach_My[] ,jach_T[]      

  num:=0;
  if (Vib_jach and 1)=1 then begin  num:=num+1;
  jach_My[ num ]:= my_min1; jach_T[ num ]:=m1;
                              end;

  if (Vib_jach and 2)=2 then  begin num:=num+1;
  jach_My[ num ]:= my_min2; jach_T[ num ]:=m2;
                              end;

  if (Vib_jach and 4)=4 then  begin num:=num+1;
   jach_My[ num ]:= my_min3;  jach_T[ num ]:=m3;
                              end;

  if (Vib_jach and 8)=8 then  begin num:=num+1;
  jach_My[ num ]:= my_min4; jach_T[ num ]:=m4;
                              end;

  if (Vib_jach and 16)=16 then  begin num:=num+1;
  jach_My[ num ]:= my_min5; jach_T[ num ]:=m5;
                               end;

  if (Vib_jach and 32)=32 then  begin num:=num+1;
  jach_My[ num ]:= my_min6; jach_T[ num ]:=m6;
                               end;

  if (Vib_jach and 64)=64 then  begin num:=num+1;
  jach_My[ num ]:= my_min7; jach_T[ num ]:=m7;
                                end;

  if (Vib_jach and 128)=128 then  begin num:=num+1;
  jach_My[ num ]:= my_min8; jach_T[ num ]:=m8;
                                end;

  if (Vib_jach and 256)=256 then  begin num:=num+1;
  jach_My[ num ]:= my_min9; jach_T[ num ]:=m9;
                               end;

   (*********************************************)

    //////    Fazzyfik


  (* 1 ------------------------------------------*)
(**)  if jach_T[1]=jach_T[2] then    (*  1 = 2 *)

  (* 2 ------------------------------------------*)
  (***)         if jach_T[1]=jach_T[3] then       (*  1 = 2 = 3 *)

  (* 3 ------------------------------------------*)
 (****)             if jach_T[1]=jach_T[4] then    (*  1 = 2 = 3 = 4 * 1*)
                        begin
                         max := jach_My[1];
                         for ii:=2 to 4 do begin
                         if max < jach_My[ii] then max:= jach_My[ii];
                                          end;
                                           ja_My_rez[1]:=max;
                        end
          (****)    else   (*  1 = 2 = 3 <> 4 *  2*)
                       begin
               max := jach_My[1];
                         for ii:=2 to 3 do begin
                         if max < jach_My[ii] then max:= jach_My[ii];
                                          end;
                             ja_My_rez[1]:=max;         ja_T_rez[1]:=jach_T[1];
                             ja_My_rez[2]:=jach_My[4]; ja_T_rez[2]:=jach_T[4];
                        end
     (* ------------------------------------------*)
    (***)   else     (* 4 ? 1 = 2 <> 3 ? 4 *)
      begin

             if jach_T[3]= jach_T[4] then
           begin     (* 4 <> 1 = 2 <> 3 = 4 * 3 *)
                  (*-----------------------------------*)
                                     if jach_My[1]> jach_My[2] then
                                          begin  ja_My_rez[1]:=jach_My[1];
                                                 ja_T_rez[1]:=jach_T[1];
                                           end
                                     else

                                           begin  ja_My_rez[1]:=jach_My[2];
                                                  ja_T_rez[1]:=jach_T[2];
                                           end;
                   (*-----------------------------------*)
                   (***-------------------------------***)
                                    if jach_My[3]> jach_My[4] then
                                           begin  ja_My_rez[2]:=jach_My[3];
                                                  ja_T_rez[2]:=jach_T[3];
                                           end
                                     else

                                           begin  ja_My_rez[2]:=jach_My[4];
                                                  ja_T_rez[2]:=jach_T[4];
                                           end;
                   (***-------------------------------***)
            end
                else  (* 4 ? 1 = 2 <> 3 <> 4 *)
            begin
                                  if jach_T[1]= jach_T[4] then   (* 4=1=2<>3<>4 * 4 *)
                    begin
                   (***-------------------------------***)
                                     max:=jach_My[1];
                                           if jach_My[2]> max then     max:=jach_My[2];
                                           if jach_My[4]> max then     max:=jach_My[4];

                                         //  begin
                                                  ja_My_rez[1]:=max;
                                                  ja_T_rez[1]:=jach_T[1];
                                                  ja_My_rez[2]:=jach_My[3];
                                                  ja_T_rez[2]:=jach_T[3];
                                         //  end;
                     end
                                    else
                                              (* 4<>1=2<>3<>4 * 5 *)

                    begin
                                           (*-----------------------------------*)
                                     if jach_My[1]> jach_My[2] then
                                          begin  ja_My_rez[1]:=jach_My[1];
                                                 ja_T_rez[1]:=jach_T[1];
                                           end
                                     else

                                           begin  ja_My_rez[1]:=jach_My[2];
                                                  ja_T_rez[1]:=jach_T[2];
                                            end;
                   (*-----------------------------------*)

                                                  ja_My_rez[2]:=jach_My[3];
                                                  ja_T_rez[2]:=jach_T[3];
                                                  ja_My_rez[3]:=jach_My[4];
                                                  ja_T_rez[3]:=jach_T[4];
                    end;
             end;

         end
 (* 3 ------------------------------------------*)

else


  (******************** 1 *************************)

  if jach_T[2]=jach_T[3] then   (* 4 ? 1 <> 2 = 3 ? 4 *)
  begin
  (*************-------------------------------*)
      (*****)  if jach_T[2]=jach_T[4] then       (* 4 <> 1 <> 2 = 3 = 4 *  6 *)
  (* 3 ------------------------------------------*)
          begin
                           max:=jach_My[2];
                           if jach_My[3]> max then     max:=jach_My[2];
                           if jach_My[4]> max then     max:=jach_My[4];

                                           begin
                                                  ja_My_rez[1]:=jach_My[1];
                                                  ja_T_rez[1]:=jach_T[1];
                                                  ja_My_rez[2]:=max;
                                                  ja_T_rez[2]:=jach_T[2];

                                           end;
          end
      (*****)        else   (* 4 ? 1 = 2 = 3 <> 4 *)
          begin
       (* ------------------------------------------*)
    (***-***)         if jach_T[1]=jach_T[4] then    (* 4= 1 <> 2 = 3 <> 4 * 7 *)
                begin
                       (*-----------------------------------*)
                    if jach_My[1]> jach_My[4] then
                                          begin  ja_My_rez[1]:=jach_My[1];
                                                 ja_T_rez[1]:=jach_T[1];
                                           end
                                     else

                                           begin  ja_My_rez[1]:=jach_My[4];
                                                  ja_T_rez[1]:=jach_T[4];
                                           end;
                   (*-----------------------------------*)
                   (***-------------------------------***)
                    if jach_My[2]> jach_My[3] then
                                           begin  ja_My_rez[2]:=jach_My[2];
                                                  ja_T_rez[2]:=jach_T[2];
                                           end
                                     else

                                           begin  ja_My_rez[2]:=jach_My[3];
                                                  ja_T_rez[2]:=jach_T[3];
                                           end;
                   (***-------------------------------***)
                end
    (*  ------------------------------------------*)
     (***-***)        else    (* 4<> 1 <> 2 = 3 <> 4 *  8 *)

                begin
                       (*-----------------------------------*)
                    if jach_My[2]> jach_My[3] then
                                          begin  ja_My_rez[2]:=jach_My[2];
                                                 ja_T_rez[2]:=jach_T[2];
                                           end
                                     else

                                           begin  ja_My_rez[2]:=jach_My[3];
                                                  ja_T_rez[2]:=jach_T[3];
                                           end;
                   (*-----------------------------------*)
                   (***-------------------------------***)
                                                  ja_My_rez[1]:=jach_My[1];
                                                  ja_T_rez[1]:=jach_T[1];
                                                  ja_My_rez[3]:=jach_My[4];
                                                  ja_T_rez[3]:=jach_T[4];

                   (***-------------------------------***)
                 end;
             end;
   end

 (******************** 2 *************************)


   else         (* 4 ? 1 <> 2 <> 3 ? 4 *)


 begin
(*----*) if jach_T[3]= jach_T[4] then    (* 4 ? 1 <> 2 <> 3 = 4 *)
       begin
   (**-*-**) if jach_T[4]= jach_T[1] then     (* 4 = 1 <> 2 <> 3 = 4 *  9 *)
                  (*-----------------------------------*)
                   begin
                                           max:=jach_My[1];
                           if jach_My[3]> max then     max:=jach_My[3];
                           if jach_My[4]> max then     max:=jach_My[4];

                                           ja_My_rez[1]:=max;
                                           ja_T_rez[1]:=jach_T[1];
                                           ja_My_rez[2]:=jach_My[2];
                                           ja_T_rez[2]:=jach_T[2];
                   end
  (**-*-**)  else            (* 4 <> 1 <> 2 <> 3 = 4 * 10 *)
                   begin
                           if jach_My[3]> jach_My[4] then
                                           begin  ja_My_rez[3]:=jach_My[3];
                                                  ja_T_rez[3]:=jach_T[3];
                                           end
                                     else

                                           begin  ja_My_rez[3]:=jach_My[4];
                                                  ja_T_rez[3]:=jach_T[4];
                                           end;
                   (***-------------------------------***)
                                           ja_My_rez[1]:=jach_My[1];
                                           ja_T_rez[1]:=jach_T[1];
                                           ja_My_rez[2]:=jach_My[2];
                                           ja_T_rez[2]:=jach_T[2];

                     end;
        end

(*----*) else
   // .........................................
        begin
       (* ------------------------------------------*)
             if jach_T[1]=jach_T[4] then    (* 4= 1 <> 2 <> 3 <> 4 * 11 *)
                        begin
                       (*-----------------------------------*)
                    if jach_My[1]> jach_My[4] then
                                          begin  ja_My_rez[1]:=jach_My[1];
                                                 ja_T_rez[1]:=jach_T[1];
                                           end
                                     else

                                           begin  ja_My_rez[1]:=jach_My[4];
                                                  ja_T_rez[1]:=jach_T[4];
                                           end;
                   (*-----------------------------------*)

                                                  ja_My_rez[2]:=jach_My[2];
                                                  ja_T_rez[2]:=jach_T[2];
                                                  ja_My_rez[3]:=jach_My[3];
                                                  ja_T_rez[3]:=jach_T[3];
                         end


    (*  ------------------------------------------*)
               else    (* 4<> 1 <> 2 <> 3 <> 4 *  12 *)

                      begin
                                                 ja_My_rez[1]:=jach_My[1];
                                                 ja_T_rez[1]:=jach_T[1];
                                                 ja_My_rez[2]:=jach_My[2];
                                                 ja_T_rez[2]:=jach_T[2];
                                                 ja_My_rez[3]:=jach_My[3];
                                                 ja_T_rez[3]:=jach_T[3];
                                                 ja_My_rez[4]:=jach_My[4];
                                                 ja_T_rez[4]:=jach_T[4];

                        end;
          end

 end;
(* 1 ------------------------------------------*)

P_temp:=0;

for  ii := 1 to 4 do
begin
  case (ja_T_rez[ ii]) of
   1: P_temp:=P_temp + vih_1* ja_My_rez[ii]*2.34;  //  
   2: P_temp:=P_temp + vih_2* ja_My_rez[ii]*2.34;// 
   3: P_temp:=P_temp + vih_3* ja_My_rez[ii]*2.34; // 
   4: P_temp:=P_temp + vih_4* ja_My_rez[ii]*2.34;// 
   5: P_temp:=P_temp + vih_5* ja_My_rez[ii]*2.34;//  
   6: P_temp:=P_temp + vih_6* ja_My_rez[ii]*2.34;//  
   7: P_temp:=P_temp + vih_7* ja_My_rez[ii]*2.34;//  
   8: P_temp:=P_temp + vih_8* ja_My_rez[ii]*2.34;//  
   9: P_temp:=P_temp + vih_9* ja_My_rez[ii]*2.34;//  
   end;
 end;

  P:= P_temp /(ja_My_rez[1]+ja_My_rez[2]+ja_My_rez[3]+ja_My_rez[4]);

  (***********************************)
  


   U_out:=P+U;
   Fuzzy:=U_out;

end;

end.
